## kfreebsd-kernel-headers 10.1~5

=== test/Makefile ===
TESTS = \
	assert_correct_bsize.o \
	assert_wchar_size.o \
	atomic.o \
	endian_collision.o \
	socket_collision.o \
	signal_collision.o \
	sig_atomic_collision.o \
	termios_collision.o \
	type_collision.o \
	time_collision.o \
	param_collision.o \
	queue_collision.o \
	limits_collision.o \
	uintXX_t.o \
	\
	bus.o \
	cpufunc.o \
	cpuset.o \
	devicestat.o \
	in_pcb.o \
	ino_t.o \
	limits.o \
	net_if.o \
	net_route.o \
	ppp.o \
	sctp.o \
	soundcard.o \
	sys_file.o \
	sys_sysctl.o \
	sys_timex.o \
	sys_user.o \
	sys_vnode.o \
	stdarg.o \
	usb.o \
	vnode.o \
	$()

#	elf.o

CFLAGS = -I. -I../debian/kfreebsd-kernel-headers/usr/include

# Enable all the stuff in glibc to probe for collisions
CFLAGS += -D_GNU_SOURCE -Werror -Wsystem-headers -Wimplicit-function-declaration

all: $(TESTS)

clean:
	rm -f $(TESTS)

=== debian/changelog ===
kfreebsd-kernel-headers (10.1~5) unstable; urgency=medium

  * Make net/route.h compilable again in userland, by including
    necessary kernel types in sys/counter.h (Closes: #764897)
    - add net_route.c testcase
  * Add sys/seq.h (sequence counters), needed by sys/filedesc.h
    - Raise Build-Depends: kfreebsd-source-10.1 (>> 10.1~svn273199~)

 -- Steven Chamberlain <steven@pyro.eu.org>  Sun, 12 Oct 2014 01:33:11 +0100

kfreebsd-kernel-headers (10.1~4) unstable; urgency=low

  [ Petr Salinger ]
  * 000_bruno_haible.diff: update of sys/timex.h:
    - do not try to support 14 years old NTP_API 3
    - do not expose declarations for ntp_adjtime, ntp_gettime at all,
      our libc does not implement them

  [ Steven Chamberlain ]
  * Add myself to Uploaders
  * Refresh patch net_if_ioctls.diff

  [ Christoph Egger ]
  * Upload to unstable

 -- Petr Salinger <Petr.Salinger@seznam.cz>  Sat,  4 Oct 2014 17:49:36 +0200

kfreebsd-kernel-headers (10.1~3) experimental; urgency=medium

  [ Steven Chamberlain ]
  * 000_bruno_haible.diff: update sys/timex.h diff from upstream:
    - define ntptimeval as ntptimeval4 (Closes: #756786)
    - add missing extern declarations for ntp_adjtime, ntp_gettime
  * Fix regressions that made libgtop2 FTBFS: (Closes: #762372)
    - Replace __FreeBSD_version with __FreeBSD_kernel_version, as was
      the case before 10.0~1.
    - Add sys/_pctrie.h, needed for sys/vnode.h if _KVM_VNODE is
      defined;  add a testcase vnode.c for this
    - New patch containerof.diff:  revert to using member2struct instead
      of __containerof in sys/fs/devfs/devfs_int.h, since the latter not
      unavailable in GNU libc sys/cdefs.h

 -- Christoph Egger <christoph@debian.org>  Sun, 21 Sep 2014 16:25:26 -0700

kfreebsd-kernel-headers (10.1~2) experimental; urgency=medium

  [ Christoph Egger ]
  * Add more pf headers:
    - netpfil/pf/pf_altq.h
    - netpfil/pf/pf.h
  * Add sys/counter.h

  [ Steven Chamberlain ]
  * Add to machine/atomic.h a definition for macro __compiler_membar
    not available in glibc (Closes: #750836)
  * Add net/if_pflog.h (Closes: #756553)
    - add atomic.c testcase (Romain Francoise)
  * Enable testing for -Wimplicit-function-declaration
  * Refresh patches against kfreebsd-source-10.1 10.1~svn271306-1:
    - 000_bruno_haible.diff
    - 005_register_t.diff
    - 009_inetutils.diff
    - net_if_ioctls.diff
  * Add sys/net/flowtable.h

 -- Christoph Egger <christoph@debian.org>  Tue, 16 Sep 2014 20:40:37 -0700

kfreebsd-kernel-headers (10.1~1) experimental; urgency=medium

  * Update for 10.1
  * Add myself to uploaders
  * Move pf_mtag.h to usr/include/netpfil/pf (new location)

 -- Christoph Egger <christoph@debian.org>  Sun, 31 Aug 2014 12:09:39 -0700

kfreebsd-kernel-headers (10.0~5) unstable; urgency=low

  * Adjust testsuite to libc0.1-dev >= 2.18-2.

 -- Robert Millan <rmh@debian.org>  Sat, 22 Mar 2014 16:19:12 +0100

kfreebsd-kernel-headers (10.0~4) experimental; urgency=low

  * Add <net/if.h>, providing only struct ifaliasreq, struct
    oifaliasreq, struct ifmediareq and struct ifdrv. Add a test for
    collisions with GNU <net/if.h>.

 -- Robert Millan <rmh@debian.org>  Mon, 03 Feb 2014 22:51:51 +0100

kfreebsd-kernel-headers (10.0~3) experimental; urgency=low

  * Expose SIZE_T_MAX, OFF_MAX and OFF_MIN. Add limits.c test to verify.
  * Enable FreeBSD-style net80211 ioctls.
  * Add <net/if_pfsync.h>, <net/pfvar.h>, <net/pf_mtag.h>,
    <sys/capability.h>, <sys/procctl.h>.
  * Remove <sys/sdt.h>. When adding it back, it should be in a separate
    package. (Closes: #726248)
  * Add <sys/diskmbr.h>.
  * Add <sys/sf_buf.h>.

 -- Robert Millan <rmh@debian.org>  Mon, 20 Jan 2014 23:44:42 +0100

kfreebsd-kernel-headers (10.0~2) experimental; urgency=low

  * Expose GID_MAX, UID_MAX, UQUAD_MAX, QUAD_MAX and QUAD_MIN.
  * Add <sys/_rmlock.h> (needed by <sys/pcpu.h>).
  * Remove obsolete (and broken) 011_wine.diff.

 -- Robert Millan <rmh@debian.org>  Wed, 15 Jan 2014 17:30:03 +0100

kfreebsd-kernel-headers (10.0~1) experimental; urgency=low

  * New upstream release.
    - Refresh all patches.
    - Update install list with new internal dependencies.
    - Misc adjustments to sed rules to preserve buildability.
    - Add new tests: assert_wchar_size.c and cpuset.c

 -- Robert Millan <rmh@debian.org>  Thu, 02 Jan 2014 13:50:33 +0100

kfreebsd-kernel-headers (9.2~6) unstable; urgency=low

  * Rename MAXLOGNAME to __kernel_MAXLOGNAME to avoid collision with
    Glibc (which now sets MAXLOGNAME to a different value).

 -- Robert Millan <rmh@debian.org>  Thu, 02 Jan 2014 16:20:12 +0100

kfreebsd-kernel-headers (9.2~5) unstable; urgency=low

  [ Guillem Jover ]
  * Remove myself from Uploaders.

  [ Robert Millan ]
  * Add <sys/mac.h>.
  * Add <sys/stdint.h> (as #include stub).
  * Add <sys/signal.h> (in alternate kglue directory), and use it
    internally instead of the userland version.
  * Add <sys/file.h> and verify its buildability and "struct file"
    usability.

 -- Robert Millan <rmh@debian.org>  Sun, 24 Nov 2013 13:38:41 +0100

kfreebsd-kernel-headers (9.2~4) unstable; urgency=low

  * Use stub headers for sys/kern rename instead of symlink.
    (Closes: #725273)

 -- Robert Millan <rmh@debian.org>  Thu, 03 Oct 2013 19:57:08 +0200

kfreebsd-kernel-headers (9.2~3) unstable; urgency=low

  * Remove 026_acpiio.diff (redundant).
  * sys_timex.c: Check <sys/timex.h> buildability.
  * Move <sys/kern> to <sys/kglue/sys> to make its origin clearer and make
    room for <sys/kglue/netinet>, etc.
  * Add <sys/kglue/netinet/if_ether.h> using patch from original port.
  * sys_user.c: Check <sys/user.h> buildability.
  * Simplify asserts using COMPILE_TIME_ASSERT() macro.
  * endian_collision.diff: Fix collisions in endian.h. Verify using
    asserts (test/endian_collision.c).
  * Filter out __used in debian/rules.
  * Install trimmed version of <sys/socket.h> and check for collisions
    in testsuite.


=== debian/control ===
Source: kfreebsd-kernel-headers
Section: kernel
Priority: standard
Maintainer: GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>
Uploaders:
 Aurelien Jarno <aurel32@debian.org>,
 Robert Millan <rmh@debian.org>,
 Christoph Egger <christoph@debian.org>,
 Steven Chamberlain <steven@pyro.eu.org>,
Build-Depends:
 debhelper (>= 7),
 quilt,
 kfreebsd-source-10.1 (>> 10.1~svn273304~),
 libc0.1-dev (>= 2.18-2~),
Vcs-Browser: http://anonscm.debian.org/viewvc/glibc-bsd/trunk/kfreebsd-kernel-headers/
Vcs-Svn: svn://anonscm.debian.org/glibc-bsd/trunk/kfreebsd-kernel-headers/
Standards-Version: 3.9.4

Package: kfreebsd-kernel-headers
Architecture: kfreebsd-any
Depends: ${misc:Depends}
Replaces: libc0.1-dev (<= 2.3.6.ds1-8)
Description: kFreeBSD headers for development
 This package provides headers from the kernel of FreeBSD. These headers
 are used by the installed headers for GNU glibc and other system libraries.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)

full_version	:= $(shell dpkg-parsechangelog | grep ^Version: | sed -e 's/^.*: //g')
version		:= $(shell echo $(full_version) | sed -e 's/[~+-].*//g')
major           := $(shell echo $(version) | sed -e 's/\..*//g')

ifeq ($(DEB_HOST_ARCH_CPU), mipsel)
kfreebsd_cpu	:= mips
else
kfreebsd_cpu	:= $(DEB_HOST_ARCH_CPU)
endif

HEADERS_PACKAGE	:= $(CURDIR)/debian/kfreebsd-kernel-headers
SRC_TAR		:= /usr/src/kfreebsd-source-$(version).tar.xz

clean:
	dh_testdir
	dh_testroot
	rm -rf .pc
	rm -f *-stamp
	rm -rf sys usr.sbin misc

	$(MAKE) -C test clean

	dh_clean

.PHONY: clean

build-indep:

build-arch: build-arch-stamp
build-arch-stamp:
	dh_testdir

	tar xfJ $(SRC_TAR) --wildcards --strip-components=1 "*.h"
	mkdir -p misc/sys

	set -e ; \
	find sys -type f | (while read i ; do \
	sed -i $$i \
		-e 's/__FreeBSD_version/__FreeBSD_kernel_version/g' \
		\
		-e 's/defined\s*(\s*__GNUCLIKE_[A-Z_]\+\s*)/defined(__GNUC__)/g' \
		-e 's/#\s*ifdef\s*__GNUCLIKE_[A-Z_]\+\(\s\|$$\)/#if defined(__GNUC__)/g' \
		-e 's/#\s*ifndef\s*__GNUCLIKE_[A-Z_]\+\(\s\|$$\)/#if !defined(__GNUC__)/g' \
		\
		-e '/^\s*__FBSDID\s*(.*)\s*;$$/d' \
		\
		-e 's/defined\s*(\s*__CC_SUPPORTS_\(INLINE\|__INLINE\|__INLINE__\|__FUNC__\|WARNING\|VARADIC_XXX\|DYNAMIC_ARRAY_INIT\)\s*)/defined(__GNUC__)/g' \
		-e 's/#\s*ifdef\s*__CC_SUPPORTS_\(INLINE\|__INLINE\|__INLINE__\|__FUNC__\|WARNING\|VARADIC_XXX\|DYNAMIC_ARRAY_INIT\)\(\s\|$$\)/#if defined(__GNUC__)/g' \
		-e 's/#\s*ifndef\s*__CC_SUPPORTS_\(INLINE\|__INLINE\|__INLINE__\|__FUNC__\|WARNING\|VARADIC_XXX\|DYNAMIC_ARRAY_INIT\)\(\s\|$$\)/#if !defined(__GNUC__)/g' \
		\
		-e 's/__unused/__attribute__((__unused__))/g' \
		-e 's/__used/__attribute__((__used__))/g' \
		-e 's/__packed\(\s\|;\)/ __attribute__((__packed__))\1/g' \
		-e 's/__aligned(\([^)]*\?\))/ __attribute__((aligned(\1)))/g' \
		-e 's/\(\s\|^\|(\)u_\(char\|int\|short\|long\)\(\s\)/\1unsigned \2\3/g' \
		-e 's/__printflike(\([0-9]\+\),\s*\([0-9]\+\))/__attribute__((__format__ (__printf__, \1, \2)))/g' \
		\
		-e 's/defined\s*(\s*_SYS_CDEFS_H_\s*)/defined(_SYS_CDEFS_H)/g' \
		-e 's/#\s*ifdef\s*_SYS_CDEFS_H_\(\s\|$$\)/#ifdef _SYS_CDEFS_H/g' \
		-e 's/#\s*ifndef\s*_SYS_CDEFS_H_\(\s\|$$\)/#ifndef _SYS_CDEFS_H/g' \
		\
		-e 's/#\s*include\s\+<sys\/types\.h>\s*/#include <sys\/kglue\/sys\/types.h>/g' \
		-e 's/#\s*include\s\+<sys\/time\.h>\s*/#include <sys\/kglue\/sys\/time.h>/g' \
		-e 's/#\s*include\s\+<sys\/param\.h>\s*/#include <sys\/kglue\/sys\/param.h>/g' \
		-e 's/#\s*include\s\+<sys\/signal\.h>\s*/#include <sys\/kglue\/sys\/signal.h>/g' \
		-e 's/#\s*include\s\+<sys\/queue\.h>\s*/#include <sys\/kglue\/sys\/queue.h>/g' \
		-e 's/#\s*include\s\+<netinet\/if_ether\.h>\s*/#include <sys\/kglue\/netinet\/if_ether.h>/g' \
		-e 's/#\s*include\s\+<sys\/_termios\.h>\s*/#include <sys\/termios.h>/g' \
		\
		-e 's/__size_t/__this_is_a_temporary_kludge__size_t/g' $(shell ## see rev 184135 in GCC SVN ##) \
		\
		-e 's/\(\s\|^\|(\)\(__\)\?ino_t\(\s\|)\|;\)/\1__kernel_ino_t\3/g' \
		-e 's/\(\s\|^\|(\)\(__\)\?MAXLOGNAME\(\s\|)\|;\)/\1__kernel_MAXLOGNAME\3/g' \
		-e 's/\(\s\|^\|(\)\(__\)\?WCHAR_MAX\(\s\|)\|;\)/\1__kernel_WCHAR_MAX\3/g' \
		-e 's/\(\s\|^\|(\)\(__\)\?WCHAR_MIN\(\s\|)\|;\)/\1__kernel_WCHAR_MIN\3/g' \
	; done)
	echo "#include <sys/kern/param.h>" > misc/osreldate.h
	echo "#include <stdint.h>" > misc/sys/stdint.h

	# Revert the kglue redirection when mistakenly applied to headers that want to
	# include the GNU version (otherwise they'll just be including themselves!)
	sed -e 's/#\s*include\s\+<sys\/kglue\/sys\/types\.h>\s*/#include <sys\/types.h>/g' -i sys/sys/types.h
	sed -e 's/#\s*include\s\+<sys\/kglue\/sys\/time\.h>\s*/#include <sys\/time.h>/g' -i sys/sys/time.h
	sed -e 's/#\s*include\s\+<sys\/kglue\/sys\/param\.h>\s*/#include <sys\/param.h>/g' -i sys/sys/param.h
	sed -e 's/#\s*include\s\+<sys\/kglue\/sys\/signal\.h>\s*/#include <sys\/signal.h>/g' -i sys/sys/signal.h
	sed -e 's/#\s*include\s\+<sys\/kglue\/sys\/queue\.h>\s*/#include <sys\/queue.h>/g' -i sys/sys/queue.h
	sed -e 's/#\s*include\s\+<sys\/kglue\/netinet\/if_ether\.h>\s*/#include <netinet\/if_ether.h>/g' -i sys/netinet/if_ether.h

	QUILT_PATCHES=$(CURDIR)/debian/patches quilt push -a || test $$? = 2

	touch $@

build: build-indep build-arch

.PHONY: build-indep build-arch build

install-indep: build-indep

install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	dh_install --sourcedir=$(CURDIR)
	dh_link

ifneq ($(filter amd64, $(kfreebsd_cpu)),)
	sh debian/generate-asm.sh $(kfreebsd_cpu) $(CURDIR)/sys $(HEADERS_PACKAGE)/usr/include
else
	mkdir -p $(HEADERS_PACKAGE)/usr/include/machine
	cd $(CURDIR)/sys/$(kfreebsd_cpu)/include \
		&& find . -type f -name "*.h" -exec cp --parents {} $(HEADERS_PACKAGE)/usr/include/machine \;
endif

ifneq ($(filter i386 amd64, $(kfreebsd_cpu)),)
	# Install "x86" directory (only on i386 and amd64).
	mkdir -p $(HEADERS_PACKAGE)/usr/include/x86
	cd $(CURDIR)/sys/x86/include \
		&& find . -type f -name "*.h" -exec cp --parents {} $(HEADERS_PACKAGE)/usr/include/x86 \;
endif

	# headers must be tested after they're installed
	$(MAKE) -C test

install: install-indep install-arch

.PHONY: install-indep install-arch install

# Build architecture-independent files here.
binary-indep: install-indep
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: install-arch
	dh_testdir
	dh_testroot
	dh_installdocs
#	dh_installman
	dh_installchangelogs
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch

.PHONY: binary-indep binary-arch binary

## kfreebsd-kernel-headers 10.3~8

=== test/Makefile ===
--- 
+++ 
@@ -1,3 +1,5 @@
+DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+
 TESTS = \
 	assert_correct_bsize.o \
 	assert_wchar_size.o \
@@ -33,12 +35,13 @@
 	sys_vnode.o \
 	stdarg.o \
 	usb.o \
+	vm.o \
 	vnode.o \
 	$()
 
 #	elf.o
 
-CFLAGS = -I. -I../debian/kfreebsd-kernel-headers/usr/include
+CFLAGS = -I. -I../debian/kfreebsd-kernel-headers/usr/include/$(DEB_HOST_MULTIARCH)
 
 # Enable all the stuff in glibc to probe for collisions
 CFLAGS += -D_GNU_SOURCE -Werror -Wsystem-headers -Wimplicit-function-declaration

=== debian/changelog ===
kfreebsd-kernel-headers (10.3~8) unstable; urgency=medium

  [ Steven Chamberlain ]
  * Update Vcs-Browser and Vcs-Git fields

  [ James Clarke ]
  * debian/rules: Add multilib symlinks for all items
  * debian/gbp.conf: Add basic config

 -- James Clarke <jrtc27@debian.org>  Fri, 18 Jan 2019 21:08:40 +0000

kfreebsd-kernel-headers (10.3~7) unstable; urgency=medium

  * Migrate packaging SVN to Git
  * Update my email address in Uploaders
  * Bump Standards-Version to 4.1.5; no change needed
  * Retroactively clean up whitespace in changelog
  * Use architecture.mk instead of dpkg-architecture
  * Use pkg-info.mk instead of dpkg-parsechangelog

 -- Steven Chamberlain <stevenc@debian.org>  Sat, 28 Jul 2018 12:07:26 +0000

kfreebsd-kernel-headers (10.3~6) unstable; urgency=medium

  * Fix crypto and isofs/cd9660 symlinks.
  * Install a 32-bit symlink for the bsm/ directory.
  * Use relative symlinks.

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 21 Nov 2017 14:31:53 +0100

kfreebsd-kernel-headers (10.3~4) unstable; urgency=medium

  * Do not install <sys/random.h>. This conflicts with the glibc one and
    doesn't provide anything useful to userland (everything is protected
    with #ifdef _KERNEL #endif).

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 20 Nov 2017 17:26:26 +0100

kfreebsd-kernel-headers (10.3~3) unstable; urgency=medium

  * Upload to unstable

 -- Steven Chamberlain <steven@pyro.eu.org>  Sat, 28 May 2016 11:25:40 +0100

kfreebsd-kernel-headers (10.3~2) experimental; urgency=medium

  * Add sys/net/ieee8023ad_lacp.h, if_vxlan.h, sff8436.h, sff8472.h;
    needed by ifconfig
  * Add sys/sys/efi.h, uuid.h; needed by sysctl
  * Add sys/sys/_timespec.h, _umtx.h, capsicum.h, umtx.h;
    needed by kdump

 -- Steven Chamberlain <steven@pyro.eu.org>  Mon, 04 Apr 2016 12:56:44 +0100

kfreebsd-kernel-headers (10.3~1) experimental; urgency=medium

  * New upstream version
  * Refresh patches:
    - queue_collision.diff
    - 000_bruno_haible.diff
    - 009_inetutils.diff
    - net_if_ioctls.diff
    - compiler_membar.diff
    - containerof.diff
  * Remove obsolete sys/netinet/in_gif.h, netinet6/in6_gif.h

 -- Steven Chamberlain <steven@pyro.eu.org>  Sat, 05 Mar 2016 03:06:35 +0000

kfreebsd-kernel-headers (10.1~8) unstable; urgency=low

  * Upload to unstable.
  * Fix typos in debian/rules introduced since 10.1~5.
    (Thanks, Helmut Grohne).
  * Fix test/Makefile to look in multiarch include dirs
  * Add new test for vm/vm.h.
  * Include kernel types to make vm/vm.h usable. (Closes: #807611)

 -- Steven Chamberlain <steven@pyro.eu.org>  Tue, 06 Oct 2015 17:25:46 +0100

kfreebsd-kernel-headers (10.1~7) experimental; urgency=medium

  * Limit libc0.1-dev dependency to !nocheck profile.  (Thanks, Helmut
    Grohne).  (Closes: #796903)
  * Note new dependency on dh-exec;  minimum versions of debhelper and
    dpkg-dev for Build-Profiles.
  * Install compatibility symlinks on kfreebsd-amd64 for -m32 multilib.
    (Closes: #797324)
  * Bump Standards-Version to 3.9.6;  no change needed.

 -- Steven Chamberlain <steven@pyro.eu.org>  Tue, 25 Aug 2015 17:12:43 +0100

kfreebsd-kernel-headers (10.1~6) experimental; urgency=medium

  * Use multiarch triplet for install paths.
  * Raise debhelper dependency version and compat level to 9.
  * Implement DEB_BUILD_OPTIONS=nocheck to allow skipping tests.

 -- Steven Chamberlain <steven@pyro.eu.org>  Thu, 20 Aug 2015 23:45:34 +0100

=== debian/control ===
--- 
+++ 
@@ -6,15 +6,17 @@
  Aurelien Jarno <aurel32@debian.org>,
  Robert Millan <rmh@debian.org>,
  Christoph Egger <christoph@debian.org>,
- Steven Chamberlain <steven@pyro.eu.org>,
+ Steven Chamberlain <stevenc@debian.org>,
 Build-Depends:
- debhelper (>= 7),
+ debhelper (>= 9.20141010~),
+ dpkg-dev (>= 1.17.14~),
+ dh-exec,
  quilt,
- kfreebsd-source-10.1 (>> 10.1~svn273304~),
- libc0.1-dev (>= 2.18-2~),
-Vcs-Browser: http://anonscm.debian.org/viewvc/glibc-bsd/trunk/kfreebsd-kernel-headers/
-Vcs-Svn: svn://anonscm.debian.org/glibc-bsd/trunk/kfreebsd-kernel-headers/
-Standards-Version: 3.9.4
+ kfreebsd-source-10.3,
+ libc0.1-dev (>= 2.18-2~) <!nocheck>,
+Standards-Version: 4.1.5
+Vcs-Browser: https://salsa.debian.org/bsd-team/kfreebsd-kernel-headers
+Vcs-Git: https://salsa.debian.org/bsd-team/kfreebsd-kernel-headers.git
 
 Package: kfreebsd-kernel-headers
 Architecture: kfreebsd-any

=== debian/rules ===
--- 
+++ 
@@ -5,19 +5,15 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
-
-full_version	:= $(shell dpkg-parsechangelog | grep ^Version: | sed -e 's/^.*: //g')
-version		:= $(shell echo $(full_version) | sed -e 's/[~+-].*//g')
-major           := $(shell echo $(version) | sed -e 's/\..*//g')
-
-ifeq ($(DEB_HOST_ARCH_CPU), mipsel)
-kfreebsd_cpu	:= mips
-else
+include /usr/share/dpkg/architecture.mk
 kfreebsd_cpu	:= $(DEB_HOST_ARCH_CPU)
-endif
 
 HEADERS_PACKAGE	:= $(CURDIR)/debian/kfreebsd-kernel-headers
+
+include /usr/share/dpkg/pkg-info.mk
+version		:= $(shell echo $(DEB_VERSION) | sed -e 's/[~+-].*//g')
+major		:= $(shell echo $(version) | sed -e 's/\..*//g')
+
 SRC_TAR		:= /usr/src/kfreebsd-source-$(version).tar.xz
 
 clean:
@@ -114,22 +110,32 @@
 	dh_link
 
 ifneq ($(filter amd64, $(kfreebsd_cpu)),)
-	sh debian/generate-asm.sh $(kfreebsd_cpu) $(CURDIR)/sys $(HEADERS_PACKAGE)/usr/include
+	sh debian/generate-asm.sh $(kfreebsd_cpu) $(CURDIR)/sys $(HEADERS_PACKAGE)/usr/include/$(DEB_HOST_MULTIARCH)
 else
-	mkdir -p $(HEADERS_PACKAGE)/usr/include/machine
+	mkdir -p $(HEADERS_PACKAGE)/usr/include/$(DEB_HOST_MULTIARCH)/machine
 	cd $(CURDIR)/sys/$(kfreebsd_cpu)/include \
-		&& find . -type f -name "*.h" -exec cp --parents {} $(HEADERS_PACKAGE)/usr/include/machine \;
+		&& find . -type f -name "*.h" -exec cp --parents {} $(HEADERS_PACKAGE)/usr/include/$(DEB_HOST_MULTIARCH)/machine \;
 endif
 
 ifneq ($(filter i386 amd64, $(kfreebsd_cpu)),)
 	# Install "x86" directory (only on i386 and amd64).
-	mkdir -p $(HEADERS_PACKAGE)/usr/include/x86
+	mkdir -p $(HEADERS_PACKAGE)/usr/include/$(DEB_HOST_MULTIARCH)/x86
 	cd $(CURDIR)/sys/x86/include \
-		&& find . -type f -name "*.h" -exec cp --parents {} $(HEADERS_PACKAGE)/usr/include/x86 \;
+		&& find . -type f -name "*.h" -exec cp --parents {} $(HEADERS_PACKAGE)/usr/include/$(DEB_HOST_MULTIARCH)/x86 \;
 endif
 
+ifneq ($(filter amd64, $(kfreebsd_cpu)),)
+	# Install compatibility symlinks for -m32 multilib (only on amd64).
+	mkdir -p $(HEADERS_PACKAGE)/usr/include/i386-kfreebsd-gnu
+	for i in `ls $(HEADERS_PACKAGE)/usr/include/$(DEB_HOST_MULTIARCH) | grep -v machine-amd64`; do \
+		ln -sf ../$(DEB_HOST_MULTIARCH)/$$i $(HEADERS_PACKAGE)/usr/include/i386-kfreebsd-gnu/ ; \
+	done
+endif
+
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# headers must be tested after they're installed
 	$(MAKE) -C test
+endif
 
 install: install-indep install-arch
